class Person {
  def activities = []
  
  def methodMissing(String name, args) {
    println "**** intercepting call to $name"
    if(name.startsWith('play')) {
      def activity = name - 'play'
      if(activities.contains(activity)) {
        println "I love to play $activity"
      } else {
        println "Sorry I don't play $activity"
      }
    } else {
      throw new MissingMethodException(name, Person, args)
    }
  }
}

def sam = new Person()
try {
  sam.run()
} catch(Exception ex) {
  println ex.message
}

sam.activities = ['Tennis', 'Football']
sam.playTennis()
sam.playTennis()
sam.playFootball()

sam.playPolitics()

def bob = new Person()
bob.playTennis()